<template>
	<ProviderProductsNormalized v-slot="slotProps" :items="items">
		<BlockAddToCartV2View
			v-bind="{ ...$props, ...slotProps }"
			:should-make-space-for-reviews="shouldMakeSpaceForReviews(slotProps.productsNormalized)"
			:has-reviews-and-ship-message="hasReviewsAndShipMessage(slotProps.productsNormalized)"
		/>
	</ProviderProductsNormalized>
</template>

<script>
import ProviderProductsNormalized from '@components/provider-products-normalized';
import BlockAddToCartV2View from '@components/block-add-to-cart-v2-view';

export default {
	components: {
		ProviderProductsNormalized,
		BlockAddToCartV2View,
	},

	props: {
		id: {
			type: String,
			default: null,
		},

		headingMobile: {
			type: String,
			default: '',
		},

		headingDesktop: {
			type: String,
			default: '',
		},

		backgroundColorMobile: {
			type: String,
			default: '',
		},

		backgroundColorDesktop: {
			type: String,
			default: '',
		},

		headingBackgroundColorMobile: {
			type: String,
			default: '',
		},

		headingBackgroundColorDesktop: {
			type: String,
			default: '',
		},

		items: {
			type: Array,
			required: true,
		},

		numberOfColumns: {
			type: [Number, String],
			default: 3,
		},

		critical: {
			type: Boolean,
			default: false,
		},
	},
	methods: {
		shouldMakeSpaceForReviews(productsNormalized) {
			let $product = productsNormalized.some((item) => item.powerreviewsPageId || item.shipMessage)
			return $product;
		},

		hasReviewsAndShipMessage(productsNormalized) {
			let $product = productsNormalized.some((item) => item.powerreviewsPageId && item.shipMessage)
			return $product;
		},
	},
};
</script>
